SystemOrganization addCategory: #Reflectogram!
SystemOrganization addCategory: 'Reflectogram-Benchmarks'!
SystemOrganization addCategory: 'Reflectogram-Case-Study'!
SystemOrganization addCategory: 'Reflectogram-Conditions-Actions'!
SystemOrganization addCategory: 'Reflectogram-Events'!
SystemOrganization addCategory: 'Reflectogram-Graph-Points'!
SystemOrganization addCategory: 'Reflectogram-Modes'!
SystemOrganization addCategory: 'Reflectogram-Targets'!
SystemOrganization addCategory: 'Reflectogram-Tests'!
SystemOrganization addCategory: 'Reflectogram-Tests-Vanilla'!

TestCase subclass: #EventTest
	instanceVariableNames: 'link'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Tests-Vanilla'!

!EventTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/5/2015 15:02'!
event

	^ Event new
! !

!EventTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/5/2015 12:34'!
expectedResultFor: aMethod

	|testObj result|
	
	testObj := self testObjectFor: aMethod.
	[ result := testObj perform: aMethod selector withEnoughArguments: { }] on: Exception do: [:ex | result := ex  ].
	
	^ result! !

!EventTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/5/2015 14:40'!
methods

	^ { }! !

!EventTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/19/2015 14:27'!
newLinkWith: aBlock

	^ MetaLink new
		metaObject: aBlock;
		selector: #value;
		control: #instead;
		options: #(+ optionCompileOnLinkInstallation).! !

!EventTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/4/2015 16:20'!
tearDown

	"additonal clean up"	
	
	link ifNotNilDo: [:l | l uninstall].
	self methods do: [:method | method recompile].	 "clean up and revert method to match each source-code"
	super tearDown.! !

!EventTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/6/2015 10:59'!
testEvent

	| expectedResult reflectiveResult metaJumpOccured |
	self methods do: [:method |
		expectedResult := self expectedResultFor: method.
		link := self newLinkWith: [metaJumpOccured := true].  
		self event 
			annotateMethod: method
			withLink: link.
			reflectiveResult := self expectedResultFor: method.
			link uninstall.
			method recompile.	"clean up and revert method to match each source-code"
			self assert: metaJumpOccured = true. "some events like sends may be triggered more than once"
			self assert: (expectedResult class = reflectiveResult class).
	]! !

!EventTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/7/2015 15:12'!
testObjectFor: aMethod
	|testObj|
	testObj := nil.
	"these do not respond to new"
	aMethod methodClass = SmalltalkImage ifTrue: [ testObj := SmalltalkImage current ].
	aMethod methodClass = SmallInteger ifTrue: [ testObj := 3 ]. 
	aMethod methodClass = Symbol ifTrue: [ testObj := #meh ].
	"proto-object does not know perform:withEnoughArgs"
	aMethod methodClass = ProtoObject ifTrue: [ testObj := Object new ]. 
	aMethod methodClass isMeta ifTrue: [ testObj := aMethod methodClass soleInstance ].
	testObj ifNil: [ testObj := aMethod methodClass new ]. 
	
	^ testObj! !

EventTest subclass: #GlobalReadTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Tests-Vanilla'!

!GlobalReadTest commentStamp: '<historical>' prior: 0!
A GlobalReadTest is a test class for testing the behavior of GlobalRead!

!GlobalReadTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/5/2015 14:08'!
event

	^ GlobalRead new! !

!GlobalReadTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/5/2015 14:32'!
methods

	^ {DummyEventTestingClass>>#globalRead}! !

!GlobalReadTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/7/2015 12:11'!
newLinkWith: aBlock

	"example of mix explicit and lazy reification (all three context / class / object reifications are found at runtime)
	but name is passed by the re-compilation process -- note here that name is known at installation time so can be hardwired
	instead of passed"

	^ MetaLink new
		metaObject: [:name | aBlock value. (thisContext sender receiver class bindingOf: name) value  ];
		selector: #value:;
		control: #instead;
		arguments: #(name);
		options: #(+ optionCompileOnLinkInstallation).! !

EventTest subclass: #IVReadTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Tests-Vanilla'!

!IVReadTest commentStamp: '<historical>' prior: 0!
An IVReadTest is a test class for testing the behavior of IVRead!

!IVReadTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/5/2015 14:58'!
event

	^ IVRead new! !

!IVReadTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/5/2015 15:01'!
methods

	^ { DummyEventTestingClass>>#readIV }! !

!IVReadTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/7/2015 12:09'!
newLinkWith: aBlock

	^ MetaLink new
		metaObject: [:name | aBlock value. thisContext sender receiver instVarNamed: name  ];
		selector: #value:;
		control: #instead;
		arguments: #(name);
		options: #(+ optionCompileOnLinkInstallation).! !

EventTest subclass: #IVWriteTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Tests-Vanilla'!

!IVWriteTest commentStamp: '<historical>' prior: 0!
An IVWriteTest is a test class for testing the behavior of IVWrite!

!IVWriteTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/5/2015 15:02'!
event
	
	^ IVWrite new! !

!IVWriteTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/5/2015 15:03'!
methods

	^ { DummyEventTestingClass>>#writeIV }! !

!IVWriteTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/7/2015 12:14'!
newLinkWith: aBlock

	^ MetaLink new
		metaObject: [:name :newValue | aBlock value. thisContext sender receiver instVarNamed: name put: newValue  ];
		selector: #value:value:;
		control: #instead;
		arguments: #(name newValue);
		options: #(+ optionCompileOnLinkInstallation).! !

EventTest subclass: #LiteralReadTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Tests-Vanilla'!

!LiteralReadTest commentStamp: '<historical>' prior: 0!
A LiteralReadTest is a test class for testing the behavior of LiteralRead!

!LiteralReadTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/5/2015 15:04'!
event
	^ LiteralRead new! !

!LiteralReadTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/5/2015 15:05'!
methods

	^ { DummyEventTestingClass>>#literalRead }! !

!LiteralReadTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/7/2015 12:35'!
newLinkWith: aBlock

	^ MetaLink new
		metaObject: [:node | aBlock value. node value  ];
		selector: #value:;
		control: #instead;
		arguments: #(node);
		options: #(+ optionCompileOnLinkInstallation).! !

EventTest subclass: #MSGReceiveTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Tests-Vanilla'!

!MSGReceiveTest commentStamp: '<historical>' prior: 0!
A MSGReceiveTest is a test class for testing the behavior of MSGReceive!

!MSGReceiveTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/5/2015 15:07'!
event

	^ MSGReceive new! !

!MSGReceiveTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/5/2015 15:07'!
methods

	^ { DummyEventTestingClass>>#msgReceive }! !

!MSGReceiveTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 10/9/2015 12:24'!
newLinkWith: aBlock

	^ MetaLink new
		metaObject: [:theNode :theLink | 
			|context initialMethod return|
			context := thisContext sender.
			aBlock value .
			theLink uninstall.
			initialMethod := context method methodClass >> context method selector.  
			return := initialMethod  valueWithReceiver: context receiver arguments: context arguments.  
			theNode link: theLink.
			return.
		];
		selector: #value:value:;
		control: #instead;
		arguments: #(node link);
		options: #(+ optionCompileOnLinkInstallation).! !

EventTest subclass: #MSGSendTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Tests-Vanilla'!

!MSGSendTest commentStamp: '<historical>' prior: 0!
A MSGSendTest is a test class for testing the behavior of MSGSend!

!MSGSendTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/5/2015 15:08'!
event

	^ MSGSend new! !

!MSGSendTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/21/2015 12:23'!
methods

	^ { DummyEventTestingClass>>#msgSend }! !

!MSGSendTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/7/2015 15:19'!
newLinkWith: aBlock

	^ MetaLink new
		metaObject: [:receiver :selector :arguments | aBlock value. receiver perform: selector withArguments: arguments  ];
		selector: #value:value:value:;
		control: #instead;
		arguments: #(receiver selector arguments);
		options: #(+ optionCompileOnLinkInstallation).! !

EventTest subclass: #MethodExecutionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Tests-Vanilla'!

!MethodExecutionTest commentStamp: '<historical>' prior: 0!
A MethodExecutionTest is a test class for testing the behavior of MethodExecution!

!MethodExecutionTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/5/2015 15:56'!
event

	^ MethodExecution new! !

!MethodExecutionTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/5/2015 15:58'!
methods

	^ { DummyEventTestingClass>>#methodExecution }! !

!MethodExecutionTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 10/9/2015 12:24'!
newLinkWith: aBlock

	^ MetaLink new
		metaObject: [:theNode :theLink | 
			|context initialMethod return|
			context := thisContext sender.
			aBlock value .
			theLink uninstall.
			initialMethod := context method methodClass >> context method selector.  
			return := initialMethod  valueWithReceiver: context receiver arguments: context arguments.  
			theNode link: theLink.
			return.
		];
		selector: #value:value:;
		control: #instead;
		arguments: #(node link);
		options: #(+ optionCompileOnLinkInstallation).! !

EventTest subclass: #ObjectCreationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Tests-Vanilla'!

!ObjectCreationTest commentStamp: '<historical>' prior: 0!
An ObjectCreationTest is a test class for testing the behavior of ObjectCreation!

!ObjectCreationTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/5/2015 16:02'!
event

	^ ObjectCreation new! !

!ObjectCreationTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/7/2015 14:35'!
methods

	^ { DummyEventTestingClass class>>#new }! !

!ObjectCreationTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 10/9/2015 13:54'!
newLinkWith: aBlock

	^ MetaLink new
		metaObject: [:theNode :theLink | 
			|context initialMethod return|
			context := thisContext sender.
			aBlock value .
			theLink uninstall.
			initialMethod := context method methodClass >> context method selector.  
			return := initialMethod  valueWithReceiver: context receiver arguments: context arguments.  
			theNode link: theLink.
			return.
		];
		selector: #value:value:;
		control: #instead;
		arguments: #(node link);
		options: #(+ optionCompileOnLinkInstallation).! !

EventTest subclass: #PassedAsArgTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Tests-Vanilla'!

!PassedAsArgTest commentStamp: '<historical>' prior: 0!
A PassedAsArgTest is a test class for testing the behavior of PassedAsArg!

!PassedAsArgTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/5/2015 17:02'!
event

	^ PassedAsArg new! !

!PassedAsArgTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/6/2015 11:01'!
methods

	^ { DummyEventTestingClass>>#passedAsArg }! !

!PassedAsArgTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 10/9/2015 13:46'!
newLinkWith: aBlock

	^ MetaLink new
		metaObject: [:receiver :selector :arguments | aBlock value. 
			"normally checking the args here for the one you are looking"

			Transcript show: receiver; cr; show: selector; cr; show: arguments; cr.
			thisContext sender top perform: selector withArguments: arguments ];
		selector: #value:value:value:;
		control: #instead;
		arguments: #(receiver selector arguments);
		options: #(+ optionCompileOnLinkInstallation).! !

EventTest subclass: #ReturnTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Tests-Vanilla'!

!ReturnTest commentStamp: '<historical>' prior: 0!
A ReturnTest is a test class for testing the behavior of Return!

!ReturnTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/5/2015 17:00'!
event

	^ Return new! !

!ReturnTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/5/2015 17:01'!
methods

	^ { DummyEventTestingClass>>#return }! !

!ReturnTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 10/9/2015 15:33'!
newLinkWith: aBlock

	^ MetaLink new
		metaObject: [:theNode :theLink | 
			|context initialMethod return|
			context := thisContext sender.
			aBlock value .
			theLink uninstall.
			initialMethod := context method methodClass >> context method selector.  
			return := initialMethod  valueWithReceiver: context receiver arguments: context arguments.  
			theNode link: theLink.
			return.
		];
		selector: #value:value:;
		control: #instead;
		arguments: #(node link);
		options: #(+ optionCompileOnLinkInstallation).! !

EventTest subclass: #ReturnedTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Tests-Vanilla'!

!ReturnedTest commentStamp: '<historical>' prior: 0!
A ReturnedTest is a test class for testing the behavior of Returned!

!ReturnedTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/5/2015 17:00'!
event

	^ Return new! !

!ReturnedTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/5/2015 17:00'!
methods

	^ { DummyEventTestingClass>>#returned: }! !

!ReturnedTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 10/9/2015 15:32'!
newLinkWith: aBlock

	^ MetaLink new
		metaObject: [:theNode :theLink | 
			|context initialMethod return|
			context := thisContext sender.
			aBlock value .
			theLink uninstall.
			initialMethod := context method methodClass >> context method selector.  
			return := initialMethod  valueWithReceiver: context receiver arguments: context arguments.  
			theNode link: theLink.
			return.
		];
		selector: #value:value:;
		control: #instead;
		arguments: #(node link);
		options: #(+ optionCompileOnLinkInstallation).! !

EventTest subclass: #StoredTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Tests-Vanilla'!

!StoredTest commentStamp: '<historical>' prior: 0!
A StoredTest is a test class for testing the behavior of Stored!

!StoredTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/5/2015 16:59'!
event
	
	^ Stored new! !

!StoredTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/5/2015 16:59'!
methods

	^ { DummyEventTestingClass>>#stored: } ! !

!StoredTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/7/2015 16:34'!
newLinkWith: aBlock

	^ MetaLink new
		metaObject: [:node :name :newValue | aBlock value. 
			node variable class = RBInstanceVariableNode "this is where we will check for the obj
			in question"
				ifTrue: [thisContext sender receiver instVarNamed: name put: newValue]  
				ifFalse: [ thisContext sender tempNamed: name put: newValue ] "temporary"
		];
		selector: #value:value:value:;
		control: #instead;
		arguments: #(node name newValue);
		options: #(+ optionCompileOnLinkInstallation).! !

EventTest subclass: #TempReadTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Tests-Vanilla'!

!TempReadTest commentStamp: '<historical>' prior: 0!
A TempReadTest is a test class for testing the behavior of TempRead!

!TempReadTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/5/2015 16:57'!
event

	^ TempRead new! !

!TempReadTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/5/2015 16:57'!
methods

	^ { DummyEventTestingClass>>#tempRead }! !

!TempReadTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/7/2015 17:11'!
newLinkWith: aBlock

	^ MetaLink new
		metaObject: [:name | aBlock value. thisContext sender tempNamed: name  ];
		selector: #value:;
		control: #instead;
		arguments: #(name);
		options: #(+ optionCompileOnLinkInstallation).! !

EventTest subclass: #TempWriteTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Tests-Vanilla'!

!TempWriteTest commentStamp: '<historical>' prior: 0!
A TempStoreTest is a test class for testing the behavior of TempStore!

!TempWriteTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/5/2015 16:42'!
event
	^ TempWrite new! !

!TempWriteTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/5/2015 16:56'!
methods

	^ { DummyEventTestingClass>>#tempWrite }! !

!TempWriteTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/7/2015 16:34'!
newLinkWith: aBlock

	^ MetaLink new
		metaObject: [:name :newValue | aBlock value. thisContext sender tempNamed: name put: newValue  ];
		selector: #value:value:;
		control: #instead;
		arguments: #(name newValue);
		options: #(+ optionCompileOnLinkInstallation).! !

TestCase subclass: #TargetEventTest
	instanceVariableNames: 'link'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Tests'!

!TargetEventTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 11/12/2015 12:42'!
event

	^ Event new
! !

!TargetEventTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 11/12/2015 12:42'!
expectedResultFor: aMethod

	|testObj result|
	
	testObj := self testObjectFor: aMethod.
	[ result := testObj perform: aMethod selector withEnoughArguments: { }] on: Exception do: [:ex | result := ex  ].
	
	^ result! !

!TargetEventTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 11/12/2015 12:42'!
methods

	^ { }! !

!TargetEventTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 11/12/2015 12:42'!
newLinkWith: aBlock

	^ MetaLink new
		metaObject: aBlock;
		selector: #value;
		control: #instead;
		options: #(+ optionCompileOnLinkInstallation).! !

!TargetEventTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 11/13/2015 13:34'!
targets

	^ { Smalltalk . "image" 
	self class package . "package"
	DummyEventTestingClass . "class"
	DummyEventTestingClass>>#aMethod . "method" 
	DummyEventTestingClass new . "object"
	[ DummyEventTestingClass new aMethodWithSuspendedContext ] newProcess . "process"
	[ DummyEventTestingClass new aMethodWithSuspendedContext ] newProcess resume suspendedContext "context" }! !

!TargetEventTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 11/12/2015 12:42'!
tearDown

	"additonal clean up"	
	
	link ifNotNilDo: [:l | l uninstall].
	self methods do: [:method | method recompile].	 "clean up and revert method to match each source-code"
	super tearDown.! !

!TargetEventTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 11/12/2015 12:42'!
testEvent

	| expectedResult reflectiveResult metaJumpOccured |
	self methods do: [:method |
		expectedResult := self expectedResultFor: method.
		link := self newLinkWith: [metaJumpOccured := true].  
		self event 
			annotateMethod: method
			withLink: link.
			reflectiveResult := self expectedResultFor: method.
			link uninstall.
			method recompile.	"clean up and revert method to match each source-code"
			self assert: metaJumpOccured = true. "some events like sends may be triggered more than once"
			self assert: (expectedResult class = reflectiveResult class).
	]! !

!TargetEventTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 11/14/2015 18:32'!
testEventWithAllTargets

	|conditionCounter actionCounter reflectiveResult expectedResult reflectoGram |

	conditionCounter := 0.
	actionCounter := 0.  
		
	self targets do: [: target |
			expectedResult := self expectedResultFor: self methods first.
			reflectoGram := ReflectoGram 
				on: target 
				as: Entity -> Flat
				for: self event 
				limitedTo: [ :method | self methods includes: method ] 
				when: [ :rPoint | conditionCounter := conditionCounter + 1 . true ]
				do: [ :rPoint | actionCounter := actionCounter + 1. rPoint returnValue: rPoint defaultAction ].
			reflectiveResult := self expectedResultFor: self methods first.
			reflectoGram uninstall.
			self methods first recompile.	"clean up and revert method to match each source-code"
			self assert: conditionCounter = 1.
			self assert: actionCounter = 1.
			self assert: (expectedResult class = reflectiveResult class).
	]! !

!TargetEventTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 11/12/2015 12:42'!
testObjectFor: aMethod
	|testObj|
	testObj := nil.
	"these do not respond to new"
	aMethod methodClass = SmalltalkImage ifTrue: [ testObj := SmalltalkImage current ].
	aMethod methodClass = SmallInteger ifTrue: [ testObj := 3 ]. 
	aMethod methodClass = Symbol ifTrue: [ testObj := #meh ].
	"proto-object does not know perform:withEnoughArgs"
	aMethod methodClass = ProtoObject ifTrue: [ testObj := Object new ]. 
	aMethod methodClass isMeta ifTrue: [ testObj := aMethod methodClass soleInstance ].
	testObj ifNil: [ testObj := aMethod methodClass new ]. 
	
	^ testObj! !

TargetEventTest subclass: #TargetGlobalReadTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Tests'!

!TargetGlobalReadTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 11/12/2015 12:45'!
event

	^ GlobalRead new! !

!TargetGlobalReadTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 11/12/2015 12:49'!
methods

	^ {DummyEventTestingClass>>#globalRead}! !

!TargetGlobalReadTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 11/12/2015 12:45'!
newLinkWith: aBlock

	"example of mix explicit and lazy reification (all three context / class / object reifications are found at runtime)
	but name is passed by the re-compilation process -- note here that name is known at installation time so can be hardwired
	instead of passed"

	^ MetaLink new
		metaObject: [:name | aBlock value. (thisContext sender receiver class bindingOf: name) value  ];
		selector: #value:;
		control: #instead;
		arguments: #(name);
		options: #(+ optionCompileOnLinkInstallation).! !

TargetEventTest subclass: #TargetPassedAsArgTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Tests'!

!TargetPassedAsArgTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 11/13/2015 12:39'!
event

	^ PassedAsArg new! !

!TargetPassedAsArgTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 11/13/2015 12:39'!
methods

	^ { DummyEventTestingClass>>#passedAsArg }! !

!TargetPassedAsArgTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 11/13/2015 12:39'!
newLinkWith: aBlock

	^ MetaLink new
		metaObject: [:receiver :selector :arguments | aBlock value. 
			"normally checking the args here for the one you are looking"

			Transcript show: receiver; cr; show: selector; cr; show: arguments; cr.
			thisContext sender top perform: selector withArguments: arguments ];
		selector: #value:value:value:;
		control: #instead;
		arguments: #(receiver selector arguments);
		options: #(+ optionCompileOnLinkInstallation).! !

Object subclass: #BenchAll
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Benchmarks'!

Object subclass: #DummyEventTestingClass
	instanceVariableNames: 'anIv'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Tests'!

!DummyEventTestingClass class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/7/2015 14:35'!
new

	"intresting here that you should either add new if it does not exist
	or intercess it in the superclass using a framework condition"

	^ super new! !

!DummyEventTestingClass methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 11/12/2015 15:55'!
aMethod! !

!DummyEventTestingClass methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 11/12/2015 16:15'!
aMethodWithSuspendedContext

	3 + 4.
	
	Processor activeProcess suspend.
	
	self foo. "does smth"! !

!DummyEventTestingClass methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 11/12/2015 16:28'!
aProcess! !

!DummyEventTestingClass methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/7/2015 12:45'!
bar

	^ 3! !

!DummyEventTestingClass methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/4/2015 11:04'!
foo! !

!DummyEventTestingClass methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/4/2015 11:07'!
foo: anArgument! !

!DummyEventTestingClass methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/4/2015 11:54'!
globalRead

	^ Object! !

!DummyEventTestingClass methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/7/2015 12:15'!
initialize
	

	anIv = 42! !

!DummyEventTestingClass methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/4/2015 11:04'!
ipsum! !

!DummyEventTestingClass methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/7/2015 12:57'!
literalRead

	^ 3! !

!DummyEventTestingClass methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/4/2015 11:03'!
lorem! !

!DummyEventTestingClass methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/4/2015 11:06'!
methodExecution

	self lorem ipsum foo bar! !

!DummyEventTestingClass methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/7/2015 12:45'!
msgReceive

	^ self lorem ipsum foo bar! !

!DummyEventTestingClass methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/7/2015 13:01'!
msgSend

	^ self lorem ipsum foo bar! !

!DummyEventTestingClass methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/7/2015 14:33'!
objectCreation

	"the new method on the other side will be intercessed"! !

!DummyEventTestingClass methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/4/2015 11:07'!
passedAsArg

	^ self foo: DummyEventTestingClass new! !

!DummyEventTestingClass methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/4/2015 11:01'!
readIV

	^ anIv ! !

!DummyEventTestingClass methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/4/2015 11:07'!
return

	^ 3! !

!DummyEventTestingClass methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/4/2015 11:08'!
returned: anIntercessedObject

	^ anIntercessedObject ! !

!DummyEventTestingClass methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/4/2015 11:08'!
stored: anIntercessedObject

	anIv := anIntercessedObject ! !

!DummyEventTestingClass methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/7/2015 17:12'!
tempRead

	|t|
	
	t := 3.
	^ t + 2! !

!DummyEventTestingClass methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/4/2015 11:10'!
tempWrite

	|t|
	
	t := 3.
	t + 2! !

!DummyEventTestingClass methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/7/2015 12:15'!
writeIV

	^ anIv := 3 ! !

Object subclass: #Event
	uses: TRBProgramNodeVisitor
	instanceVariableNames: 'link'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Events'!

Event class
	uses: TRBProgramNodeVisitor classTrait
	instanceVariableNames: 'default'!

Event class
	uses: TRBProgramNodeVisitor classTrait
	instanceVariableNames: 'default'!

!Event methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 11/15/2015 16:10'!
annotateMethod: aMethod forTarget: aTarget 

	self subclassResponsibility 
! !

!Event methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/5/2015 14:35'!
annotateMethod: aMethod withLink: aMetaLink 

	link := aMetaLink.
	self visitNode: aMethod ast! !

!Event methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/29/2015 15:36'!
resolveScopeFor: aTarget

	self subclassResponsibility ! !

!Event methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/23/2015 20:08'!
scope

	self subclassResponsibility ! !

!Event methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 11/14/2015 18:47'!
uninstall

	link ifNotNil: [ link uninstall ]
! !

Event subclass: #MultiScopedEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Events'!

!MultiScopedEvent methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 10/16/2015 12:34'!
scope

	^ MultiScope! !

MultiScopedEvent subclass: #RealMultiScoped
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Events'!

RealMultiScoped subclass: #PassedAsArg
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Events'!

!PassedAsArg methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 11/15/2015 16:13'!
annotateMethod: aMethod forTarget: aTarget 
	
	|aLink|

	"Put an Interpreter here"

	aLink := MetaLink new "something like this should be optimized"
		metaObject: [:receiver :selector :arguments | 
			"normally checking the args here for the one you are looking"
			|defaultAction p returnValue|
			"normally you can get all reifications lazily"
			defaultAction := [thisContext sender top perform: selector withArguments: arguments].
			aTarget entityConditionGroupingInstances 
					ifTrue: [  
						p := aTarget reflectogram 
							newPointFor: aTarget
							withDefaultAction: defaultAction
							in: thisContext. "this is used for the reifications".
						aTarget userCondition ifNil: [  
							aTarget userAction value: p
						] ifNotNil: [ 
							(aTarget userCondition value: p) 
								ifTrue: [ aTarget userAction value: p ]
								ifFalse: [ p returnValue: defaultAction value ].
							returnValue := p returnValue.
						] 
					] ifFalse: [  
						returnValue := defaultAction value
					].
			returnValue
		];
		selector: #value:value:value:;
		control: #instead;
		arguments: #(receiver selector arguments);
		options: #(+ optionCompileOnLinkInstallation).
		
		self annotateMethod: aMethod withLink: link.! !

!PassedAsArg methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/23/2015 20:04'!
visitMessageNode: aMessageNode 
	aMessageNode link: link.
	^ super visitMessageNode: aMessageNode.! !

!RealMultiScoped methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/29/2015 16:01'!
resolveScopeFor: aTarget

	aTarget realMultiScopedEvent: self! !

!RealMultiScoped methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/29/2015 15:59'!
scope

	^ RealMultiScope ! !

RealMultiScoped subclass: #Returned
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Events'!

!Returned methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 10/9/2015 14:26'!
visitMethodNode: aMethodNode 
	aMethodNode link: link.
	^ super visitMethodNode: aMethodNode.! !

RealMultiScoped subclass: #Stored
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Events'!

!Stored methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 11/11/2015 18:38'!
visitAssignmentNode: anAssignmentNode
	"((anAssignmentNode variable isInstance))  
		ifTrue: [  ]."
	anAssignmentNode link: link.
	^ super visitAssignmentNode: anAssignmentNode.! !

MultiScopedEvent subclass: #SimulatedMultiScoped
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Events'!

SimulatedMultiScoped subclass: #MSGReceive
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Events'!

!MSGReceive methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/7/2015 15:21'!
visitMethodNode: aMethodNode 
	aMethodNode link: link.
	^ super visitMethodNode: aMethodNode.! !

SimulatedMultiScoped subclass: #ObjectCreation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Events'!

!ObjectCreation methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 11/11/2015 18:33'!
visitMethodNode: aMethodNode 
	aMethodNode link: link.
	^ super visitMethodNode: aMethodNode.! !

!SimulatedMultiScoped methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/29/2015 16:01'!
resolveScopeFor: aTarget

	aTarget simulatedMultiScopedEvent: self! !

!SimulatedMultiScoped methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/29/2015 15:59'!
scope

	^ SimulatedMultiScope ! !

Event subclass: #SingleScopedEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Events'!

SingleScopedEvent subclass: #GlobalRead
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Events'!

!GlobalRead methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/5/2015 14:35'!
visitGlobalNode: aGlobalNode
	aGlobalNode link: link.
	^ super visitVariableNode: aGlobalNode.! !

SingleScopedEvent subclass: #IVRead
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Events'!

!IVRead methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/6/2015 11:30'!
visitVariableNode: aVariableNode
	((aVariableNode isInstance) & (aVariableNode parent ~= AssignmentNode)) "read" 
		ifTrue: [ aVariableNode link: link ].
	^ super visitVariableNode: aVariableNode.! !

SingleScopedEvent subclass: #IVWrite
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Events'!

!IVWrite methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/6/2015 11:32'!
visitAssignmentNode: anAssignmentNode
	((anAssignmentNode variable isInstance)) "iv" 
		ifTrue: [ anAssignmentNode link: link ].
	^ super visitAssignmentNode: anAssignmentNode.! !

SingleScopedEvent subclass: #LiteralRead
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Events'!

!LiteralRead methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/7/2015 12:32'!
visitLiteralNode: aLiteralNode

	aLiteralNode link: link.
	^ super visitVariableNode: aLiteralNode.! !

SingleScopedEvent subclass: #MSGSend
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Events'!

!MSGSend methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/23/2015 18:14'!
visitMessageNode: aMessageNode 
	aMessageNode link: link.
	^ super visitMessageNode: aMessageNode.! !

SingleScopedEvent subclass: #MethodExecution
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Events'!

!MethodExecution methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/23/2015 18:36'!
visitMethodNode: aMethodNode 
	aMethodNode link: link.
	^ super visitMethodNode: aMethodNode.! !

SingleScopedEvent subclass: #Return
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Events'!

!Return methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 10/9/2015 14:26'!
visitMethodNode: aMethodNode 
	aMethodNode link: link.
	^ super visitMethodNode: aMethodNode.! !

!SingleScopedEvent methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/29/2015 15:36'!
resolveScopeFor: aTarget

	aTarget singleScopedEvent: self.! !

!SingleScopedEvent methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 10/16/2015 12:34'!
scope

	^ SingleScope! !

SingleScopedEvent subclass: #TempRead
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Events'!

!TempRead methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 10/9/2015 14:09'!
visitTemporaryNode: aNode 
	"Sent *each time* a temporary node is found"
	aNode isRead "read" 
		ifTrue: [ aNode link: link ].
	^ super visitTemporaryNode: aNode.! !

SingleScopedEvent subclass: #TempWrite
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Events'!

!TempWrite methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/6/2015 12:23'!
visitAssignmentNode: anAssignmentNode
	((anAssignmentNode variable isTemp)) "iv" 
		ifTrue: [ anAssignmentNode link: link ].
	^ super visitAssignmentNode: anAssignmentNode.! !

!TempWrite methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/6/2015 11:34'!
visitStoreIntoTempNode: aNode
	"this is never called -- is done through assignment visit and checking"
	aNode link: link.
	^ super visitStoreIntoTempNode: aNode.! !

Object subclass: #MetaAction
	instanceVariableNames: 'blockClosure'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Conditions-Actions'!

MetaAction subclass: #FrameWorkMetaAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Conditions-Actions'!

MetaAction subclass: #UserMetaAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Conditions-Actions'!

Object subclass: #MetaCondition
	instanceVariableNames: 'blockClosure'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Conditions-Actions'!

MetaCondition subclass: #FrameworkMetaCondition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Conditions-Actions'!

MetaCondition subclass: #InstallationMetaCondition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Conditions-Actions'!

MetaCondition subclass: #UserMetaCondition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Conditions-Actions'!

Object subclass: #Mode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Modes'!

Mode subclass: #Scope
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Modes'!

Scope subclass: #MultiScope
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Modes'!

MultiScope subclass: #RealMultiScope
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Modes'!

MultiScope subclass: #SimulatedMultiScope
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Modes'!

Scope subclass: #SingleScope
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Modes'!

SingleScope subclass: #LexicalScope
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Modes'!

SingleScope subclass: #RunTimeScope
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Modes'!

Mode subclass: #Semantics
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Modes'!

!Semantics commentStamp: 'NickPapoulias 7/23/2015 19:16' prior: 0!
semantics of hierarchy and reification!

Semantics subclass: #Hierarchy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Modes'!

Hierarchy subclass: #Flat
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Modes'!

Hierarchy subclass: #Inheritance
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Modes'!

Semantics subclass: #Reification
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Modes'!

Reification subclass: #Entity
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Modes'!

Reification subclass: #Instance
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Modes'!

Object subclass: #RTVarAnalysis
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Case-Study'!

Object subclass: #Reflecto
	instanceVariableNames: ''
	classVariableNames: 'BaseMetaDict'
	poolDictionaries: ''
	category: 'Reflectogram-Graph-Points'!

!Reflecto class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 10/15/2015 15:55'!
baseMetaDict

	^ BaseMetaDict ifNil: [ BaseMetaDict := Dictionary new ]
	
	
	! !

!Reflecto class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 11/14/2015 19:49'!
on: anEntity as: semanticsPair for: anEvent limitedTo: installationCondition when: userCondition do: userAction

	"single methods can be treated through class -- same for contexts"
	
	| reification hierarchy target |
	
	reification := semanticsPair key. "Instance -> Flat etc"
	hierarchy  := semanticsPair value.
	
	target := (reification = Instance) "This can also be done with Target on:given: replicating here for clarity" 
		ifTrue: [ ObjectTarget new target: anEntity  ] "treat as object"
		ifFalse: [ (Target resolve: anEntity) new target: anEntity ]. "treat as entity -- which also includes objects"
	
	target 
		setScopeFor: anEvent; "major scope and sub scope"
		calculateAffectedMethodsGiven: hierarchy. 
	
	installationCondition
		ifNotNil: [ target limitAffectedMethodsGiven: installationCondition ].
	
	target
		userCondition: userCondition;
		userAction: userAction.
	
	^ (ReflectoGram of: anEntity) 
			addTarget: (target install; yourself);
			yourself! !

!Reflecto class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 10/11/2015 13:39'!
on: anEntity for: anEvent limitedTo: installationCondition when: userCondition do: userAction
	
	| defaultSemanticPair |
	defaultSemanticPair := (Target resolve: anEntity) defaultSemanticPair.
	^ self 
		on: anEntity 
		as: defaultSemanticPair 
		for: anEvent 
		limitedTo: installationCondition 
		when: userCondition 
		do: userAction! !

!Reflecto class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 10/11/2015 13:38'!
on: anEntity for: anEvent when: userCondition do: userAction
	
	^ self on: anEntity for: anEvent limitedTo: nil when: userCondition do: userAction
	
	
	! !

Reflecto subclass: #ReflectoGram
	instanceVariableNames: 'targetObject targets traced points'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Graph-Points'!

!ReflectoGram class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 11/14/2015 19:49'!
of: anEntity

	^ self baseMetaDict at: anEntity ifAbsentPut: (self new on: anEntity)! !

!ReflectoGram methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 10/15/2015 16:04'!
addTarget: aTarget

	targets add: aTarget! !

!ReflectoGram methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 11/14/2015 18:45'!
disable! !

!ReflectoGram methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 11/14/2015 18:44'!
enable! !

!ReflectoGram methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 11/14/2015 18:44'!
install! !

!ReflectoGram methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 10/15/2015 15:57'!
on: anEntity

	targetObject := anEntity.
	targets := OrderedCollection new. 
	traced := false. 
	points := OrderedCollection new.! !

!ReflectoGram methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 10/15/2015 16:03'!
traced: aBoolean

	traced := aBoolean.! !

!ReflectoGram methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 11/14/2015 20:38'!
uninstall

	targets do: [ :target | target uninstall ]! !

Reflecto subclass: #ReflectoPoint
	instanceVariableNames: 'target defaultAction traced tracedTime tracedReifications'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Graph-Points'!

Object subclass: #ReflectoGramVisualization
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Graph-Points'!

Object subclass: #Target
	instanceVariableNames: 'scope reification hierarchy affectedMethods affectedClasses installCondition targetedObject associatedEvent userAction userCondition'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Targets'!

Target class
	instanceVariableNames: 'resolveDict'!

Target class
	instanceVariableNames: 'resolveDict'!

Target subclass: #ClassTarget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Targets'!

!ClassTarget methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 10/11/2015 13:46'!
defaultAffectedClasses

	^ {targetedObject} asOrderedCollection ! !

!ClassTarget methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 11/13/2015 12:48'!
entityConditionGroupingInstances
	
	^ [ :object | object class = targetedObject ]! !

!ClassTarget methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 10/16/2015 12:35'!
singleScopedEvent: anEvent

	scope := LexicalScope ! !

Target subclass: #ContextTarget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Targets'!

!ContextTarget methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 10/11/2015 13:46'!
calculateAffectedMethodsGiven: anHierarchy

	affectedMethods := {targetedObject method} asOrderedCollection! !

!ContextTarget methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 10/11/2015 13:46'!
defaultAffectedClasses

	^ {targetedObject method class} asOrderedCollection
	! !

!ContextTarget methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/3/2015 12:03'!
defaultAffectedHierarchy

	self shouldNotImplement 
	! !

!ContextTarget methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/29/2015 16:21'!
realMultiScopedEvent: anEvent

	self shouldNotImplement ! !

!ContextTarget methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/29/2015 16:21'!
simulatedMultiScopedEvent: anEvent

	self shouldNotImplement ! !

!ContextTarget methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 10/16/2015 12:35'!
singleScopedEvent: anEvent

	scope := RunTimeScope ! !

Target subclass: #ImageTarget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Targets'!

!ImageTarget methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/3/2015 12:21'!
defaultAffectedClasses

	^ ProtoObject allSubclasses! !

!ImageTarget methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/3/2015 12:09'!
defaultAffectedHierarchy
	
	^ ProtoObject allSubclasses! !

!ImageTarget methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 10/16/2015 12:35'!
singleScopedEvent: anEvent

	scope := LexicalScope ! !

Target subclass: #MethodTarget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Targets'!

!MethodTarget methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 10/11/2015 13:46'!
calculateAffectedMethodsGiven: anHierarchy

	affectedMethods := {targetedObject} asOrderedCollection! !

!MethodTarget methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 10/11/2015 13:46'!
defaultAffectedClasses
	
	^ targetedObject methodClass! !

!MethodTarget methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/3/2015 12:10'!
defaultAffectedHierarchy
	
	self shouldNotImplement 
	! !

!MethodTarget methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/29/2015 16:22'!
realMultiScopedEvent: anEvent

	self shouldNotImplement ! !

!MethodTarget methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/29/2015 16:22'!
simulatedMultiScopedEvent: anEvent

	self shouldNotImplement ! !

!MethodTarget methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 10/16/2015 12:35'!
singleScopedEvent: anEvent

	scope := LexicalScope ! !

Target subclass: #ObjectTarget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Targets'!

!ObjectTarget class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 10/11/2015 13:34'!
defaultSemanticPair

	^ Instance -> Flat! !

!ObjectTarget methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 10/11/2015 13:46'!
defaultAffectedClasses
	
	^ {targetedObject class} asOrderedCollection ! !

!ObjectTarget methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 10/16/2015 12:35'!
singleScopedEvent: anEvent

	scope := RunTimeScope ! !

Target subclass: #PackageTarget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Targets'!

!PackageTarget methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 10/11/2015 13:46'!
defaultAffectedClasses
	
	^ targetedObject classes! !

!PackageTarget methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 11/13/2015 12:49'!
entityConditionGroupingInstances
	
	^ [ :object | object class package = targetedObject ]! !

!PackageTarget methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 10/16/2015 12:35'!
singleScopedEvent: anEvent

	scope := LexicalScope ! !

Target subclass: #ProcessTarget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Targets'!

!ProcessTarget methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 10/11/2015 13:46'!
calculateAffectedMethodsGiven: anHierarchy

	"start with the suspended context and then just intercess on return and on send"

	targetedObject suspend.
	affectedMethods := {targetedObject suspendedContext method} asOrderedCollection! !

!ProcessTarget methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 10/11/2015 13:46'!
defaultAffectedClasses

	targetedObject suspend.
	^ {targetedObject suspendedContext method methodClass} asOrderedCollection ! !

!ProcessTarget methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 8/3/2015 12:29'!
defaultAffectedHierarchy

	self shouldNotImplement ! !

!ProcessTarget methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/29/2015 16:22'!
realMultiScopedEvent: anEvent

	self shouldNotImplement ! !

!ProcessTarget methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/29/2015 16:22'!
simulatedMultiScopedEvent: anEvent

	self shouldNotImplement ! !

!ProcessTarget methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 10/16/2015 12:35'!
singleScopedEvent: anEvent

	scope := RunTimeScope ! !

!Target class methodsFor: 'accessing' stamp: 'NickPapoulias 10/11/2015 13:34'!
defaultSemanticPair

	^ Entity -> Flat! !

!Target class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/25/2015 13:09'!
on: anEntity

	^ self on: anEntity given: Entity! !

!Target class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/25/2015 13:08'!
on: anEntity given: reification
	
	(reification = Instance) 
		ifTrue: [ ^ ObjectTarget new target: anEntity  ] "treat as object"
		ifFalse: [ ^ (Target resolve: anEntity) new target: anEntity ]. "treat as entity -- which also includes objects"	! !

!Target class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 11/14/2015 20:37'!
resolve: anEntity
	
	self resolveDict keysAndValuesDo: [ :classKey : targetClass |
		(anEntity isKindOf: classKey) ifTrue: [ ^ targetClass ]		
	].

	^ ObjectTarget
	! !

!Target class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 11/14/2015 20:35'!
resolveDict
	
	^ resolveDict ifNil: [resolveDict := { Context -> ContextTarget . SmalltalkImage -> ImageTarget . CompiledMethod ->MethodTarget .RPackage -> PackageTarget . Process -> ProcessTarget . Class -> ClassTarget } asDictionary]  
! !

!Target methodsFor: 'accessing' stamp: 'NickPapoulias 11/14/2015 19:52'!
calculateAffectedClassesGiven: anHierarchy

	scope = RealMultiScoped ifFalse: [  
	
		hierarchy := anHierarchy.
	
		anHierarchy = Flat
			ifTrue: [ affectedClasses := self defaultAffectedClasses ]
			ifFalse: [ affectedClasses := self defaultAffectedHierarchy ]
	
	] ifTrue: [  
	
			affectedClasses := ProtoObject allSubclasses.
	]! !

!Target methodsFor: 'scoping-public' stamp: 'NickPapoulias 8/3/2015 11:47'!
calculateAffectedMethodsGiven: anHierarchy

	self calculateAffectedClassesGiven: anHierarchy.
	affectedMethods := affectedClasses flatCollect: [ :class | class methodDict values ]! !

!Target methodsFor: 'accessing' stamp: 'NickPapoulias 8/3/2015 12:18'!
defaultAffectedClasses

	self subclassResponsibility ! !

!Target methodsFor: 'accessing' stamp: 'NickPapoulias 8/3/2015 12:20'!
defaultAffectedHierarchy

	| nextClass hierarchyCollection |
	self defaultAffectedClasses do: [ :aClass | 
		nextClass := aClass.
		hierarchyCollection := OrderedCollection new.
		[ nextClass ] whileNotNil: [ hierarchyCollection add: nextClass. nextClass := nextClass superclass ].
	].
	^ hierarchyCollection! !

!Target methodsFor: 'accessing' stamp: 'NickPapoulias 11/13/2015 12:54'!
entityConditionGroupingInstances

	self shouldNotImplement ! !

!Target methodsFor: 'accessing' stamp: 'NickPapoulias 10/15/2015 16:28'!
install
		
	affectedMethods "currently this only depends " 
		do: [: method |  associatedEvent annotateMethod: method forTarget: self "the event should know" ].! !

!Target methodsFor: 'scoping-public' stamp: 'NickPapoulias 8/3/2015 12:38'!
limitAffectedMethodsGiven: installationCondition

	installCondition := installationCondition.
	affectedMethods := affectedMethods select: installCondition.
	affectedClasses := (affectedMethods collect: [ :method | method methodClass ]) asSet.! !

!Target methodsFor: 'accessing' stamp: 'NickPapoulias 7/29/2015 16:02'!
realMultiScopedEvent: anEvent

	scope := anEvent scope! !

!Target methodsFor: 'accessing' stamp: 'NickPapoulias 11/14/2015 19:51'!
setScopeFor: anEvent

	anEvent resolveScopeFor: self.
	associatedEvent := anEvent.! !

!Target methodsFor: 'accessing' stamp: 'NickPapoulias 7/29/2015 16:02'!
simulatedMultiScopedEvent: anEvent

	scope := anEvent scope! !

!Target methodsFor: 'accessing' stamp: 'NickPapoulias 7/29/2015 15:37'!
singleScopedEvent: anEvent

	self subclassResponsibility ! !

!Target methodsFor: 'accessing' stamp: 'NickPapoulias 10/11/2015 13:46'!
target
	^ targetedObject! !

!Target methodsFor: 'accessing' stamp: 'NickPapoulias 10/11/2015 13:46'!
target: anObject
	targetedObject := anObject! !

!Target methodsFor: 'accessing' stamp: 'NickPapoulias 11/14/2015 18:47'!
uninstall
		
	associatedEvent uninstall! !

!Target methodsFor: 'accessing' stamp: 'NickPapoulias 10/11/2015 14:44'!
userAction
	^ userAction! !

!Target methodsFor: 'accessing' stamp: 'NickPapoulias 10/11/2015 14:44'!
userAction: anObject
	userAction := anObject! !

!Target methodsFor: 'accessing' stamp: 'NickPapoulias 10/11/2015 14:44'!
userCondition
	^ userCondition! !

!Target methodsFor: 'accessing' stamp: 'NickPapoulias 10/11/2015 14:44'!
userCondition: anObject
	userCondition := anObject! !

Object subclass: #View
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Case-Study'!

Object subclass: #WebApp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Case-Study'!
